Index: gravitywars-1.102/GravityWars101.c
===================================================================
--- gravitywars-1.102.orig/GravityWars101.c	2006-05-16 06:33:25.000000000 +0200
+++ gravitywars-1.102/GravityWars101.c	2006-05-16 06:33:28.000000000 +0200
@@ -92,16 +92,24 @@
     } while ( (strncmp(arg[1],codes[n],6)) && (n<99));
     if (n!=99) {
       levelnum=n+1;
+#ifndef USE_SDL
       if (n_args>2)
 	delay_len=atoi(arg[2]);
+#endif
     } else {
+#ifdef USE_SDL
+      printf("\nUsage: %s [code-to-a-given-level]\n"
+	     "(Sure you've got the right code?)\n\n",arg[0]);
+      exit(0);
+#else
       if ((arg[1][0]<'0') || (arg[1][0]>'9')) {
 	printf("\nUsage: %s [code-to-a-given-level] [beam-adjustment]\n"
 	       "(Sure you've got the right code?)\n\n",arg[0]);
 	exit(0);
       }
-      else 
+      else
 	delay_len=atoi(arg[1]);
+#endif
     } 
   }    
   
Index: gravitywars-1.102/Makefile
===================================================================
--- gravitywars-1.102.orig/Makefile	1996-11-02 16:54:18.000000000 +0100
+++ gravitywars-1.102/Makefile	2006-05-16 06:33:28.000000000 +0200
@@ -2,15 +2,23 @@
 # Makefile for Gravity Wars, by Sami Niemi
 #
 
+USE_SDL=1
+
 BINDIR=/usr/local/bin
 
-CFLAGS=-O2 -s  
+ifeq (1,$(USE_SDL))
+CFLAGS= -g -O2 -Wall -DUSE_SDL `sdl-config --cflags`
+LIBS= -lm `sdl-config --libs`
+else
+CFLAGS= -O2 -Wall
+LIBS= -lm -lvgagl -lvga
+endif
+
 CC=cc
-LIBS=-lm -lvgagl -lvga
 TARGET=GravityWars101
 OBJECTS=memory.o macros.o misc.o water.o score.o hole.o bullet.o pixel.o \
         blocks.o introutro.o animate.o init.o makepic.o scroll.o moveship.o \
-        control.o GravityWars101.o 
+        control.o vgastubs.o GravityWars101.o 
 
 $(TARGET): $(OBJECTS)
 	$(CC) $(CFLAGS) $(OBJECTS) $(OBJECTS2) -o $(TARGET) $(LIBS)
@@ -49,6 +57,8 @@
 
 control.o: control.c config.h macros.h
 
+vgastubs.o: vgastubs.c vgastubs.h
+
 
 clean:
 	rm -f $(OBJECTS)
Index: gravitywars-1.102/blocks.c
===================================================================
--- gravitywars-1.102.orig/blocks.c	1996-08-25 09:48:22.000000000 +0200
+++ gravitywars-1.102/blocks.c	2006-05-16 06:33:28.000000000 +0200
@@ -18,15 +18,22 @@
  
   vga_setpage(mask);
  
+#ifdef USE_SDL
+  if (1) {
+#else
   if (adr < 45024) {
+#endif
 
     /* NORMAL */
     address=vga_ptr+adr;
     for (yy=0; yy<=31; yy++) {
-      for (xx=0; xx<=31; xx++) {
+      memcpy(address,dp,32);
+      address+=640;
+      dp+=32;
+   /* for (xx=0; xx<=31; xx++) {
         *(address++)=*(dp++);
       }
-      address+=608;
+      address+=608; */
     }
 
   }
Index: gravitywars-1.102/control.c
===================================================================
--- gravitywars-1.102.orig/control.c	2006-05-16 06:33:20.000000000 +0200
+++ gravitywars-1.102/control.c	2006-05-16 06:33:28.000000000 +0200
@@ -1,6 +1,10 @@
 /* GravityWars 1.1,  (C) Sami Niemi -95 */
 
+#ifdef USE_SDL
+#include "vgastubs.h"
+#else
 #include <vgakeyboard.h>
+#endif
 #include "memory.h"
 
  
Index: gravitywars-1.102/includes.h
===================================================================
--- gravitywars-1.102.orig/includes.h	1996-08-25 09:48:22.000000000 +0200
+++ gravitywars-1.102/includes.h	2006-05-16 06:33:28.000000000 +0200
@@ -1,8 +1,12 @@
 #include <stdio.h>
+#ifdef USE_SDL
+#include "vgastubs.h"
+#else
 #include <vgakeyboard.h>
 #include <vgamouse.h>
 #include <vgagl.h>
 #include <vga.h>
+#endif
 #include <math.h>
 #include <stdlib.h>
 #include <unistd.h>
Index: gravitywars-1.102/init.c
===================================================================
--- gravitywars-1.102.orig/init.c	2006-05-16 06:33:26.000000000 +0200
+++ gravitywars-1.102/init.c	2006-05-16 06:33:28.000000000 +0200
@@ -1,9 +1,14 @@
+
 /* GravityWars 1.1,  (C) Sami Niemi -95 */
 
+#ifdef USE_SDL
+#include "vgastubs.h"
+#else
 #include <vga.h>
 #include <vgagl.h>
-#include <math.h>
 #include <asm/io.h>
+#endif
+#include <math.h>
 #include "memory.h"
 
 /*--------------------------------------------------------------- initScreen */
@@ -12,6 +17,12 @@
   short n,ptr;
   uchar reg;
 
+  /* This modification for debian lets it stay sgid games, so it can write to
+   * the high score file. */
+#ifndef USE_SDL
+  setgid(getegid());
+#endif
+
   vga_init();
   vga_setmode(G640x480x256);
   gl_setcontextvga(G640x480x256);
@@ -22,6 +33,9 @@
   gl_setpalette(p0); 
 
   /* Split Screen (sl=SplitScreenLine)   */
+#ifdef USE_SDL
+  vga_setsplitline(464);
+#else
   outb(0x18,0x3d4);       /* LineCompare */
   outb(208,0x3d5);        /* sl&255      */
   outb(7,0x3d4);          /* Overflow    */
@@ -30,7 +44,8 @@
   outb(9,0x3d4);          /* Maximum Scanline */
   reg=inb(0x3d5);          
   outb(reg&191,0x3d5);    /* outb(reg|((sl&512)>>3),0x3d5) */
-  
+#endif
+  return 0;
 }					
 
 /*--------------------------------------------------------------- initParams */
Index: gravitywars-1.102/introutro.c
===================================================================
--- gravitywars-1.102.orig/introutro.c	2006-05-16 06:33:24.000000000 +0200
+++ gravitywars-1.102/introutro.c	2006-05-16 06:33:28.000000000 +0200
@@ -1,9 +1,13 @@
 /* GravityWars 1.1,  (C) Sami Niemi -95 */
 
+#ifdef USE_SDL
+#include "vgastubs.h"
+#else
 #include <vgakeyboard.h>
-#include <math.h>
 #include <vga.h>
 #include <asm/io.h>
+#endif
+#include <math.h>
 #include "memory.h"
  
 void intro() {
@@ -122,6 +126,9 @@
 
 
   /* Split Screen (sl=SplitScreenLine)   */
+#ifdef USE_SDL
+  vga_setsplitline(480);
+#else
   outb(0x18,0x3d4);       /* LineCompare */
   outb(0,0x3d5);        /* sl&255      */
   outb(7,0x3d4);          /* Overflow    */
@@ -130,7 +137,7 @@
   outb(9,0x3d4);          /* Maximum Scanline */
   reg=inb(0x3d5);          
   outb(reg&191,0x3d5);    /* outb(reg|((sl&512)>>3),0x3d5) */
-  
+#endif
 
 
 
@@ -214,6 +221,9 @@
   gl_setpalette(p0);
 
   /* Split Screen (sl=SplitScreenLine)   */
+#ifdef USE_SDL
+  vga_setsplitline(464);
+#else
   outb(0x18,0x3d4);       /* LineCompare */
   outb(208,0x3d5);        /* sl&255      */
   outb(7,0x3d4);          /* Overflow    */
@@ -222,9 +232,8 @@
   outb(9,0x3d4);          /* Maximum Scanline */
   reg=inb(0x3d5);          
   outb(reg&191,0x3d5);    /* outb(reg|((sl&512)>>3),0x3d5) */
-  
+#endif
 
-  
 }
 
 
Index: gravitywars-1.102/moveship.c
===================================================================
--- gravitywars-1.102.orig/moveship.c	2006-05-16 06:33:21.000000000 +0200
+++ gravitywars-1.102/moveship.c	2006-05-16 06:33:28.000000000 +0200
@@ -1,6 +1,11 @@
 /* GravityWars 1.1,  (C) Sami Niemi -95 */
 
+#ifdef USE_SDL
+  /* */
+#else
 #include <asm/io.h>
+#endif
+#include <string.h>
 #include "memory.h"
 #include "macros.h"
 
@@ -480,6 +485,9 @@
 
   /* Roll The Split Screen Down   */
 	  for(sl=464; sl<=480; sl++) {
+#ifdef USE_SDL
+	    vga_setsplitline(sl);
+#else
 	    outb(0x18,0x3d4);       /* LineCompare */
 	    outb(sl&255,0x3d5);        
 	    outb(7,0x3d4);          /* Overflow    */
@@ -488,6 +496,7 @@
 	    outb(9,0x3d4);          /* Maximum Scanline */
 	    reg=inb(0x3d5);          
 	    outb(reg|((sl&512)>>3),0x3d5); 
+#endif
 	    vga_waitretrace();
 	  }
 
@@ -617,6 +626,9 @@
 
 	  /* Roll the SplitScreen Up   */
 	  for(sl=480; sl>=464; sl--) {
+#ifdef USE_SDL
+	    vga_setsplitline(sl);
+#else
 	    outb(0x18,0x3d4);       /* LineCompare */
 	    outb(sl&255,0x3d5);        
 	    outb(7,0x3d4);          /* Overflow    */
@@ -625,6 +637,7 @@
 	    outb(9,0x3d4);          /* Maximum Scanline */
 	    reg=inb(0x3d5);          
 	    outb(reg|((sl&512)>>3),0x3d5); 
+#endif
 	    vga_waitretrace();
 	  }
 
@@ -667,7 +680,7 @@
 	if (blocktype==E_BONUS)  {
 	  beep(15000);
 
-	  backptr=shipback[nr];
+	  //backptr=shipback[nr];
 
 	  tmp1=37+(rand()&1);
 	  tmp2=lx+(ly<<4)+(ly<<2);
@@ -684,7 +697,7 @@
 	  if (blocktype==E_WBONUS)  {
 	    beep(15000);
 
-	    backptr=shipback[nr];
+	    //backptr=shipback[nr];
  
 	    tmp2=lx+(ly<<4)+(ly<<2);
 	    
@@ -735,8 +748,11 @@
     putbox(old_x, old_y, shipback[nr]); 
     putbox(x, y, shipmix);
 
-    for(n=0; n<=1023; n++) shipback[nr][n]=backptr[n];
+    //for(n=0; n<=1023; n++) shipback[nr][n]=backptr[n];
+    memcpy(shipback[nr],backptr,1024);
   }
+
+  return 0;
 }
 
 
Index: gravitywars-1.102/scroll.c
===================================================================
--- gravitywars-1.102.orig/scroll.c	1996-08-25 10:55:30.000000000 +0200
+++ gravitywars-1.102/scroll.c	2006-05-16 06:33:28.000000000 +0200
@@ -71,7 +71,9 @@
 	animate();
 #endif
 
+#ifndef USE_SDL
 	for(n=0; n<=delay_len; n++);
+#endif
 
 #ifdef SCORE
 	killscore(nr,win_y,y);
@@ -92,9 +94,11 @@
       }
       vga_waitretrace();
       
+#ifndef USE_SDL
       delay_len=delay_len<<1;
       for(n=0; n<=delay_len; n++);
       delay_len=delay_len>>1;
+#endif
  
 #ifdef SCORE
       killscore(nr,win_y,y2);
@@ -114,7 +118,9 @@
 	animate();
 #endif
 
+#ifndef USE_SDL
 	for(n=0; n<=delay_len; n++);
+#endif
 
 #ifdef SCORE
         killscore(nr,win_y,y);
@@ -133,10 +139,11 @@
       vga_waitretrace();
       gl_setdisplaystart(0,y2-8);
 
+#ifndef USE_SDL
       delay_len=delay_len<<1;
       for(n=0; n<=delay_len; n++);
       delay_len=delay_len>>1;
- 
+#endif
 
 #ifdef SCORE
       killscore(nr,win_y,y2);
Index: gravitywars-1.102/vgastubs.c
===================================================================
--- /dev/null	1970-01-01 00:00:00.000000000 +0000
+++ gravitywars-1.102/vgastubs.c	2006-05-16 06:33:28.000000000 +0200
@@ -0,0 +1,249 @@
+
+/* GravityWars 1.1, SDL wrapper (C) 2003 Sam Hocevar <sam@zoy.org> */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "memory.h"
+
+#ifdef USE_SDL
+#include "vgastubs.h"
+
+#include <SDL.h>
+
+/* VGA */
+
+#define WIDTH 640
+#define HEIGHT 480
+
+SDL_Surface *screen;
+SDL_Surface *bg;
+SDL_Rect score_rect, level_rect, game_rect;
+
+int vga_init(void) {
+  if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_NOPARACHUTE) < 0)
+    return -1;
+
+  atexit(SDL_Quit);
+
+  return 0;
+}
+
+int vga_setmode(int mode) {
+
+  switch(mode) {
+    case G640x480x256:
+      screen = SDL_SetVideoMode(WIDTH, HEIGHT, 8,
+                                SDL_HWPALETTE/*|SDL_FULLSCREEN*/);
+      if(!screen) {
+        fprintf(stderr, "error setting %dx%d 8bpp indexed mode: %s\n",
+                WIDTH, HEIGHT, SDL_GetError());
+        return -1;
+      }
+      break;
+    case TEXT:
+      break;
+  }
+
+  /* The level area in the background bitmap */
+  level_rect.w = WIDTH;
+  level_rect.h = HEIGHT;
+  level_rect.x = 0;
+  level_rect.y = 16; /* gets modified, between 16 and 960 */
+
+  /* Where our viewport gets blitted */
+  game_rect.w = WIDTH;
+  game_rect.h = HEIGHT;
+  game_rect.x = 0;
+  game_rect.y = 0;
+
+  /* The score area in the background bitmap */
+  score_rect.w = WIDTH;
+  score_rect.h = 0;
+  score_rect.x = 0;
+  score_rect.y = 16;
+
+  /* Where the score gets blitted - heh, we use NULL! */
+
+  return 0;
+}
+
+/* This one is SDL-only */
+void vga_setsplitline(int sl) {
+  score_rect.h = 480 - sl;
+  score_rect.y = 16 - (480 - sl);
+}
+
+#ifndef MIN
+#define MIN(a, b) ((a) < (b) ? (a) : (b))
+#endif
+#ifndef MAX
+#define MAX(a, b) ((a) > (b) ? (a) : (b))
+#endif
+
+int vga_claimvideomemory(int m) {
+  bg = SDL_CreateRGBSurface(SDL_SWSURFACE, WIDTH, m / WIDTH, 8, 0, 0, 0, 0);
+
+  if(!bg)
+    return -1;
+
+  /* set the palette to the logical screen palette so that blits
+     won't be translated */
+  SDL_SetColors(bg, screen->format->palette->colors, 0, 256);
+
+  vga_setpage(0);
+
+  return 0;
+}
+
+unsigned char *vga_getgraphmem(void) {
+  return bg->pixels;
+}
+
+/* FIXME: implement this as a macro */
+void vga_setpage(int page) {
+  vga_ptr = bg->pixels + (page << 16);
+}
+
+void vga_waitretrace(void) {
+  SDL_BlitSurface(bg, &level_rect, screen, &game_rect);
+  SDL_BlitSurface(bg, &score_rect, screen, NULL);
+  SDL_UpdateRect(screen, 0, 0, 0, 0);
+}
+
+/* gl */
+
+void gl_setpalette(void *sp) {
+  SDL_Color cmap[256];
+  char *cols = (char *)sp;
+  int i;
+
+  for(i=0; i<256; i++) {
+    cmap[i].r = *cols++ * 4;
+    cmap[i].g = *cols++ * 4;
+    cmap[i].b = *cols++ * 4;
+  }
+
+  SDL_SetPalette(screen, SDL_PHYSPAL, cmap, 0, 256);
+}
+
+int gl_setcontextvga(int mode) {
+  return 0;
+}
+
+void  gl_setcontextvirtual(int  w,  int  h,  int  bpp, int bitspp, void *vbuf) {
+  return;
+}
+
+void *gl_setdisplaystart(int x, int y) {
+  level_rect.x = x;
+  level_rect.y = y; /* y >= 16 */
+
+  return NULL;
+}
+
+void gl_setpalettecolor(int c, int r, int g, int b) {
+  SDL_Color cmap[1];
+  cmap[0].r = r * 4;
+  cmap[0].g = g * 4;
+  cmap[0].b = b * 4;
+
+  SDL_SetColors(screen, cmap, 0, 1);
+}
+
+/* Mouse */
+
+int mouse_init(char *dev, int type, int samplerate) {
+  return 0;
+}
+
+int mouse_update(void) {
+  return 0;
+}
+
+int mouse_getbutton(void) {
+  return 0;
+}
+
+void mouse_close(void) {
+  return;
+}
+
+/* Keyboard */
+
+unsigned char keybuf[256];
+
+int keyboard_init(void) {
+  scans = keybuf;
+  memset(scans, 0, 256);
+  return 0;
+}
+
+void keyboard_close(void) {
+  return;
+}
+
+char *keyboard_getstate(void) {
+  return scans;
+}
+
+int keyboard_update(void) {
+  SDL_Event e;
+  int updated = 0;
+  int mod;
+
+  mod = SDL_GetModState();
+  scans[SCANCODE_LEFTCONTROL] = mod & KMOD_LCTRL;
+  scans[SCANCODE_RIGHTCONTROL] = mod & KMOD_RCTRL;
+
+  while(SDL_PollEvent(&e)) {
+    if(e.type == SDL_KEYDOWN) {
+      switch(e.key.keysym.sym) {
+        case SDLK_ESCAPE:
+          scans[SCANCODE_ESCAPE] = 1;
+          updated = 1;
+          break;
+        case SDLK_LEFT:
+          scans[SCANCODE_CURSORBLOCKLEFT] = 1;
+          updated = 1;
+          break;
+        case SDLK_RIGHT:
+          scans[SCANCODE_CURSORBLOCKRIGHT] = 1;
+          updated = 1;
+          break;
+        case SDLK_UP:
+          scans[SCANCODE_CURSORBLOCKUP] = 1;
+          updated = 1;
+          break;
+        case SDLK_f:
+          SDL_WM_ToggleFullScreen(screen);
+          break;
+        default:
+          updated = 1;
+          break;
+      }
+    } else if(e.type == SDL_KEYUP) {
+      switch(e.key.keysym.sym) {
+        case SDLK_ESCAPE:
+          scans[SCANCODE_ESCAPE] = 0;
+          break;
+        case SDLK_LEFT:
+          scans[SCANCODE_CURSORBLOCKLEFT] = 0;
+          break;
+        case SDLK_RIGHT:
+          scans[SCANCODE_CURSORBLOCKRIGHT] = 0;
+          break;
+        case SDLK_UP:
+          scans[SCANCODE_CURSORBLOCKUP] = 0;
+          break;
+        default:
+          break;
+      }
+    }
+  }
+
+  return updated;
+}
+
+#endif /* USE_SDL */
Index: gravitywars-1.102/vgastubs.h
===================================================================
--- /dev/null	1970-01-01 00:00:00.000000000 +0000
+++ gravitywars-1.102/vgastubs.h	2006-05-16 06:33:28.000000000 +0200
@@ -0,0 +1,41 @@
+
+/* GravityWars 1.1, SDL wrapper (C) 2003 Sam Hocevar <sam@zoy.org> */
+
+#define TEXT 0
+#define G640x480x256 1
+#define MOUSE_MICROSOFT 0
+#define MOUSE_DEFAULTSAMPLERATE 0
+#define SCANCODE_ESCAPE 0
+
+#define BYTESPERPIXEL 1
+#define BITSPERPIXEL 8
+#define VBUF 0
+
+#define SCANCODE_ESCAPE 0
+#define SCANCODE_LEFTCONTROL 1
+#define SCANCODE_RIGHTCONTROL 2
+#define SCANCODE_CURSORBLOCKLEFT 3
+#define SCANCODE_CURSORBLOCKRIGHT 4
+#define SCANCODE_CURSORBLOCKUP 5
+
+typedef void vga_modeinfo;
+
+int vga_init(void);
+int vga_setmode(int mode);
+void vga_setsplitline(int sl);
+int vga_claimvideomemory(int m);
+unsigned char *vga_getgraphmem(void);
+void vga_setpage(int page);
+void gl_setpalette(void *sp);
+int gl_setcontextvga(int mode);
+void  gl_setcontextvirtual(int  w,  int  h,  int  bpp, int bitspp, void *vbuf);
+void *gl_setdisplaystart(int x, int y);
+void gl_setpalettecolor(int c, int r, int g, int b);
+int mouse_init(char *dev, int type, int samplerate);
+int mouse_update(void);
+int mouse_getbutton(void);
+void mouse_close(void);
+int keyboard_init(void);
+void keyboard_close(void);
+char *keyboard_getstate(void);
+int keyboard_update(void);
